<%@ Application Codebehind="Global.asax.cs" Inherits="CommunityServer.Global" %>
<%@ Import Namespace="CuteChat" %>

<script runat=server Language=C#>

	public override void Init()
	{
		base.Init();

		lock(typeof(CuteChat.ChatSystem))
		{
			if(!CuteChat.ChatSystem.HasStarted)
			{
				CuteChat.ChatProvider.Instance=new CSChatProvider();
				CuteChat.ChatSystem.Start(new CuteChat.AppSystem());
			}
		}
	}

    public class CSChatProvider : ChatProvider
    {
        public override string GetConnectionString()
        {
            string connectionstring = Telligent.Components.DataProvider.GetConnectionString();
		    if(connectionstring==null||connectionstring.Trim()=="")
			    throw(new Exception("Missing appSetting : SiteSqlServer"));
		    return connectionstring.Trim();
        }

        public override AppChatIdentity GetLogonIdentity()
        {
            CommunityServer.Components.User user = CommunityServer.Users.GetUser();
            if (user == null || user.IsAnonymous)
                return null;
            return new AppChatIdentity(user.DisplayName, false, ToUserId(user.Username), HttpContext.Current.Request.UserHostAddress);
        }


        private CommunityServer.Components.User SafeFindUser(string username)
        {
            HttpContext context = HttpContext.Current;
            if (context != null)
                return CommunityServer.Users.FindUserByUsername(username);

            try
            {
                CommunityServer.Components.CSContext csc = CommunityServer.Components.CSContext.Create(1);

                return CommunityServer.Users.FindUserByUsername(username);
            }
            catch
            {
                return null;
            }
        }

        public override string FindUserLoginName(string nickName)
        {
            CommunityServer.Components.User user = SafeFindUser(nickName);
            if (user == null || user.IsAnonymous)
                return null;
            return user.DisplayName;
        }
        public override bool GetUserInfo(string loginName, ref string nickName, ref bool isAdmin)
        {
            CommunityServer.Components.User user = SafeFindUser(loginName);
            if (user == null || user.IsAnonymous)
                return false;
            nickName = user.DisplayName;
            isAdmin = user.IsAdministrator;
            return true;
        }
        public override bool ValidateUser(string loginName, string password)
        {
            if (!Membership.ValidateUser(loginName, password)) return false;
            System.Web.Security.FormsAuthentication.SetAuthCookie(loginName, false, "/");
            return true;
        }
    }

</script>